diff --git a/src/include/access/nbtree_specialize.h b/src/include/access/nbtree_specialize.h
new file mode 100644
index 0000000000..23fdda4f0e
--- /dev/null
+++ b/src/include/access/nbtree_specialize.h
@@ -0,0 +1,204 @@
+/*-------------------------------------------------------------------------
+ *
+ * nbtree_specialize.h
+ *	  header file for postgres btree access method implementation.
+ *
+ *
+ * Portions Copyright (c) 1996-2022, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/include/access/nbtree_specialize.h
+ *
+ *-------------------------------------------------------------------------
+ *
+ * Specialize key-accessing functions and the hot code around those.
+ *
+ * Key attribute iteration is specialized through the use of the following
+ * macros:
+ *
+ * - nbts_call(function, indexrel, ...rest_of_args), and
+ *   nbts_call_norel(function, indexrel, ...args)
+ *     This will call the specialized variant of 'function' based on the index
+ *     relation data.
+ *     The difference between nbts_call and nbts_call_norel is that _call
+ *     uses indexrel as first argument in the function call, whereas
+ *     nbts_call_norel does not.
+ * - nbts_attiterdeclare(itup)
+ *   Declare the variables required to iterate over the provided IndexTuple's
+ *   key attributes. Many tuples may have their attributes iterated over at the
+ *   same time.
+ * - nbts_attiterinit(itup, initAttNum, tupDesc)
+ *   Initialize the attribute iterator for the provided IndexTuple at
+ *   the provided AttributeNumber.
+ * - nbts_foreachattr(initAttNum, endAttNum)
+ *   Start a loop over the attributes, starting at initAttNum and ending at
+ *   endAttNum, inclusive. It also takes care of truncated attributes.
+ * - nbts_attiter_attnum
+ *   The current attribute number
+ * - nbts_attiter_nextattdatum(itup, tupDesc)
+ *   Updates the attribute iterator state to the next attribute. Returns the
+ *   datum of the next attribute, which might be null (see below)
+ * - nbts_attiter_curattisnull(itup)
+ *   Returns whether the result from the last nbts_attiter_nextattdatum is
+ *   null.
+ *
+ * example usage:
+ *
+ * kwithnulls = nbts_call_norel(_bt_key_hasnulls, myindex, mytuple, tupDesc);
+ *
+ * NBTS_FUNCTION(_bt_key_hasnulls)(IndexTuple mytuple, TupleDesc tupDesc)
+ * {
+ *    nbts_attiterdeclare(mytuple);
+ *    nbts_attiterinit(mytuple, 1, tupDesc);
+ *    nbts_foreachattr(1, 10)
+ *    {
+ *        Datum it = nbts_attiter_nextattdatum(tuple, tupDesc);
+ *        if (nbts_attiter_curattisnull(tuple))
+ *           return true;
+ *    }
+ *    return false
+ * }
+ */
+
+/*
+ * Call a potentially specialized function for a given btree operation.
+ *
+ * NB: the rel argument is evaluated multiple times.
+ */
+#define nbts_call(name, rel, ...) \
+	nbts_call_norel(name, (rel), (rel), __VA_ARGS__)
+
+#ifdef NBTS_ENABLED
+
+#define NBTS_FUNCTION(name) NBTS_MAKE_NAME(name, NBTS_TYPE)
+
+#ifdef nbts_call_norel
+#undef nbts_call_norel
+#endif
+
+#define nbts_call_norel(name, rel, ...) \
+	(NBTS_FUNCTION(name)(__VA_ARGS__))
+
+/*
+ * Multiple key columns, optimized access for attcacheoff -cacheable offsets.
+ */
+#define NBTS_SPECIALIZING_CACHED
+#define NBTS_TYPE NBTS_TYPE_CACHED
+
+#define nbts_attiterdeclare(itup) \
+	bool	NBTS_MAKE_NAME(itup, isNull)
+
+#define nbts_attiterinit(itup, initAttNum, tupDesc)
+
+#define nbts_foreachattr(initAttNum, endAttNum) \
+	for (int spec_i = (initAttNum); spec_i <= (endAttNum); spec_i++)
+
+#define nbts_attiter_attnum spec_i
+
+#define nbts_attiter_nextattdatum(itup, tupDesc) \
+	index_getattr((itup), spec_i, (tupDesc), &(NBTS_MAKE_NAME(itup, isNull)))
+
+#define nbts_attiter_curattisnull(itup) \
+	NBTS_MAKE_NAME(itup, isNull)
+
+#include NBT_SPECIALIZE_FILE
+
+#undef NBTS_TYPE
+#undef NBTS_SPECIALIZING_CACHED
+#undef nbts_attiterdeclare
+#undef nbts_attiterinit
+#undef nbts_foreachattr
+#undef nbts_attiter_attnum
+#undef nbts_attiter_nextattdatum
+#undef nbts_attiter_curattisnull
+
+/* reset call to SPECIALIZE_CALL for default behaviour */
+#undef nbts_call_norel
+#define nbts_call_norel(name, rel, ...) \
+	NBT_SPECIALIZE_CALL(name, (rel), __VA_ARGS__)
+
+/*
+ * "Default", externally accessible, not so much optimized functions
+ */
+
+#define NBTS_SPECIALIZING_DEFAULT
+#define NBTS_TYPE NBTS_TYPE_DEFAULT
+
+/* for the default functions, we want to use the unspecialized name. */
+#undef NBTS_FUNCTION
+#define NBTS_FUNCTION(name) name
+
+
+#define nbts_attiterdeclare(itup) \
+	bool	NBTS_MAKE_NAME(itup, isNull)
+
+#define nbts_attiterinit(itup, initAttNum, tupDesc)
+
+#define nbts_foreachattr(initAttNum, endAttNum) \
+	for (int spec_i = (initAttNum); spec_i <= (endAttNum); spec_i++)
+
+#define nbts_attiter_attnum spec_i
+
+#define nbts_attiter_nextattdatum(itup, tupDesc) \
+	index_getattr((itup), spec_i, (tupDesc), &(NBTS_MAKE_NAME(itup, isNull)))
+
+#define nbts_attiter_curattisnull(itup) \
+	NBTS_MAKE_NAME(itup, isNull)
+
+#include NBT_SPECIALIZE_FILE
+
+#undef NBTS_TYPE
+#undef NBTS_SPECIALIZING_DEFAULT
+#undef nbts_attiterdeclare
+#undef nbts_attiterinit
+#undef nbts_foreachattr
+#undef nbts_attiter_attnum
+#undef nbts_attiter_nextattdatum
+#undef nbts_attiter_curattisnull
+
+/* from here on there are no more NBTS_FUNCTIONs */
+#undef NBTS_FUNCTION
+
+#else /* not defined NBTS_ENABLED */
+
+/*
+ * NBTS_ENABLE is not defined, so we don't want to use the specializations.
+ * We revert to the behaviour from PG14 and earlier, which only uses
+ * attcacheoff.
+ */
+
+#define NBTS_FUNCTION(name) name
+
+#define nbts_call_norel(name, rel, ...) \
+	name(__VA_ARGS__)
+
+#define NBTS_TYPE NBTS_TYPE_CACHED
+
+#define nbts_attiterdeclare(itup) \
+	bool	NBTS_MAKE_NAME(itup, isNull)
+
+#define nbts_attiterinit(itup, initAttNum, tupDesc)
+
+#define nbts_foreachattr(initAttNum, endAttNum) \
+	for (int spec_i = (initAttNum); spec_i <= (endAttNum); spec_i++)
+
+#define nbts_attiter_attnum spec_i
+
+#define nbts_attiter_nextattdatum(itup, tupDesc) \
+	index_getattr((itup), spec_i, (tupDesc), &(NBTS_MAKE_NAME(itup, isNull)))
+
+#define nbts_attiter_curattisnull(itup) \
+	NBTS_MAKE_NAME(itup, isNull)
+
+#include NBT_SPECIALIZE_FILE
+
+#undef NBTS_TYPE
+#undef nbts_attiterdeclare
+#undef nbts_attiterinit
+#undef nbts_foreachattr
+#undef nbts_attiter_attnum
+#undef nbts_attiter_nextattdatum
+#undef nbts_attiter_curattisnull
+
+
+#endif /* !NBTS_ENABLED */
diff --git a/src/include/access/nbtree_specialized.h b/src/include/access/nbtree_specialized.h
new file mode 100644
index 0000000000..c45fa84aed
--- /dev/null
+++ b/src/include/access/nbtree_specialized.h
@@ -0,0 +1,67 @@
+/*
+ * prototypes for functions that are included in nbtree.h
+ */
+
+/*
+ * prototypes for functions in nbtree_spec.h
+ */
+extern void
+NBTS_FUNCTION(_bt_specialize)(Relation rel);
+
+extern bool
+NBTS_FUNCTION(btinsert)(Relation rel, Datum *values, bool *isnull,
+						ItemPointer ht_ctid, Relation heapRel,
+						IndexUniqueCheck checkUnique,
+						bool indexUnchanged,
+						struct IndexInfo *indexInfo);
+
+/*
+ * prototypes for functions in nbtdedup_spec.h
+ */
+extern void
+NBTS_FUNCTION(_bt_dedup_pass)(Relation rel, Buffer buf, Relation heapRel,
+							  IndexTuple newitem, Size newitemsz,
+							  bool bottomupdedup);
+
+
+/*
+ * prototypes for functions in nbtinsert_spec.h
+ */
+
+extern bool
+NBTS_FUNCTION(_bt_doinsert)(Relation rel, IndexTuple itup,
+							IndexUniqueCheck checkUnique, bool indexUnchanged,
+							Relation heapRel);
+
+/*
+ * prototypes for functions in nbtsearch_spec.h
+ */
+extern BTStack
+NBTS_FUNCTION(_bt_search)(Relation rel, BTScanInsert key,
+						  Buffer *bufP, int access,
+						  Snapshot snapshot);
+extern Buffer
+NBTS_FUNCTION(_bt_moveright)(Relation rel, BTScanInsert key, Buffer buf,
+							 bool forupdate, BTStack stack, int access,
+							 Snapshot snapshot);
+extern OffsetNumber
+NBTS_FUNCTION(_bt_binsrch_insert)(Relation rel, BTInsertState insertstate);
+extern int32
+NBTS_FUNCTION(_bt_compare)(Relation rel, BTScanInsert key,
+						   Page page, OffsetNumber offnum);
+
+/*
+ * prototypes for functions in nbtutils_spec.h
+ */
+extern BTScanInsert
+NBTS_FUNCTION(_bt_mkscankey)(Relation rel, IndexTuple itup);
+extern bool
+NBTS_FUNCTION(_bt_checkkeys)(Relation rel, IndexScanDesc scan,
+							 IndexTuple tuple, int tupnatts,
+							 ScanDirection dir, bool *continuescan);
+extern IndexTuple
+NBTS_FUNCTION(_bt_truncate)(Relation rel, IndexTuple lastleft,
+							IndexTuple firstright, BTScanInsert itup_key);
+extern int
+NBTS_FUNCTION(_bt_keep_natts_fast)(Relation rel, IndexTuple lastleft,
+								   IndexTuple firstright);
-- 
2.30.2

